<?php

/*

Plugin Name: GeotagPhoto

Plugin URI: http://www.placemarkers.co.uk

Description: enables all photos with geotag information to be clicked on to show where they were taken.

Version: 0.7

Author: Dave Stivens

Author URI: http://www.placemarkers.co.uk

*/



/*  Copyright 2009  Dave Stivens  



    This program is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    This program is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with this program; if not, write to the Free Software

    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


global $geotagphoto_options;

$geotagphoto_options = get_option("geotagphoto_options");



	add_filter("the_content", "tagContent" );

	add_action('wp_head', 'thickboxmap_java');

	add_action('wp_footer', 'thickboxmap_div');

	add_action('admin_menu', 'geotagphoto_menu');





	function tagContent($content="") 

	{

		$URL = get_bloginfo('wpurl');



		$post_id = $post->ID;



		global $post;

		preg_match_all("/<img[^>]+src=['\"]*([^'\" ]*)['\" ][^>]*>/i", $post->post_content, $result); 



		foreach( $result[1] as $key => $image ) 

		{			
			if( !file_exists( $image ) )
			{
				$finalpath = str_replace( $URL, $_SERVER["DOCUMENT_ROOT"], $image);			

			}
			else
			{
				$finalpath = $image;	
			}

			if( file_exists( $finalpath ) )
			{

				$exif = exif_read_data( $finalpath, 0, true );


				if (!empty($exif["GPS"])) 

				{

					$lat_sec = explode("/", $exif["GPS"]["GPSLatitude"][2]);

					$lon_sec = explode("/", $exif["GPS"]["GPSLongitude"][2]);

					$lat = intval($exif["GPS"]["GPSLatitude"][0]) + ((intval($exif["GPS"]["GPSLatitude"][1]) + ($lat_sec[0] / $lat_sec[1] / 60)) / 60);

					$lon = intval($exif["GPS"]["GPSLongitude"][0]) + ((intval($exif["GPS"]["GPSLongitude"][1]) + ($lon_sec[0] / $lon_sec[1] / 60)) / 60);



					if($exif["GPS"]["GPSLatitudeRef"] == "S")

					{

						$lat = -$lat;

					}



					if($exif["GPS"]["GPSLongitudeRef"] == "W") 

					{

						$lon = -$lon;

					}

$CurTypeOn = "'pointer'";

					$content = ereg_replace( $result[0][ $key ], '<div style=" position:relative; top:0; left:0; z-index:3;"><a href="' . $image . '" class="thickbox"><img src="' . $image . '" ></a><div style="position:absolute; top:0px; left:0px; z-index:4;"><img src="' . get_bloginfo('wpurl') . '/wp-content/plugins/geotagphoto/images/marker.png" onclick="gload( ' . $lat . ',' . $lon .' , 300, 500);" onmouseover="this.style.cursor=' . $CurTypeOn . ';" ></div></div>', $content );



				}
			}
		}

		return $content;

	}



	function thickboxmap_java() 

	{

		$API_KEY = get_option("geotagphoto_api_key");

		echo '<script type="text/javascript" src="' . get_bloginfo('wpurl') . '/wp-content/plugins/geotagphoto/geotagphoto.js" ></script>'."\n";

    echo '<script type="text/javascript" src="wp-includes/js/jquery/jquery.js"></script>'."\n";

    echo '<script type="text/javascript" src="wp-includes/js/thickbox/thickbox.js"></script>'."\n";

    echo '<style type="text/css" media="all">@import "wp-includes/js/thickbox/thickbox.css";</style>'."\n";


		echo '<script src="http://maps.google.com/maps?file=api&v=1&key=' . $API_KEY . '" type="text/javascript"></script>';

	}

	

	function thickboxmap_div() 

	{

		echo '<div id="test_map" style="display:none" ></div>';	

	}





	function geotagphoto_menu() 

	{

	  add_options_page('GeotagPhoto Options', 'GeotagPhoto', 8, 'geotagphoto.php', 'geotagphoto_options');

	}



	function geotagphoto_options() 

	{

		global $geotagphoto_options;



		$geotagphoto_api_key = get_option("geotagphoto_api_key");



	    echo '<div class="wrap">';

	    echo '<form method="post" action="options.php">';



	    wp_nonce_field('update-options');



	    echo "	<table class='form-table'>

					<tr valign='top'>

						<th scope='row'>Google API Key</th>

						<td><input name='geotagphoto_api_key' type='text' value='".$geotagphoto_api_key."' size='50' ";

							if (empty($geotagphoto_api_key)) {echo "style='border: 1px solid #d54e21; background-color: #ffebe8;'";}

							echo " /><br />

							You need a unique Google API Key for your website to display Google Maps. If you don't have one yet, <a href='http://code.google.com/apis/maps/signup.html' target='_blank'>sign up</a> to get one!</td>

					</tr>

				</table>

				<p class='submit'>

					<input type='submit' name='submit' value='Save Changes' class='button-primary' />

					<input type='hidden' name='action' value='update' />

					<input type='hidden' name='page_options' value='geotagphoto_api_key' />

				</p>

		</form>";



	  echo '</div>';

	}





?>
